#include "node/lua_vm/def.h"

#pragma once

namespace schpin
{

struct msg_event
{
        nlohmann::json j;
};

struct msg_bind
{

        static constexpr std::string_view name = "msg";
        static constexpr std::string_view desc = "creates message out of json";

        inline static const auto arg =
            slua_struct< msg_event >( lua_key_arg< nlohmann::json >{ "json", "data" } );
        inline static const auto res = slua_result< nlohmann::json >{ "Response message" };
};

struct print_config_event
{
};

struct print_config_bind
{
        static constexpr std::string_view name = "print_config";
        static constexpr std::string_view desc = "print_config information about servo";

        inline static const auto           arg = slua_struct< print_config_event >();
        inline static const no_return_type res{};
};

struct quit_event
{
        int res;
};

struct quit_bind
{
        static constexpr std::string_view name = "quit";
        static constexpr std::string_view desc = "closes the app";

        inline static const auto arg =
            slua_struct< quit_event >( lua_key_arg< int >{ "res", "Result return id of the app" } );
        inline static const no_return_type res{};
};

struct print_help_event
{
};

struct print_help_bind
{
        static constexpr std::string_view name = "print_help";
        static constexpr std::string_view desc = "Prints binding help";

        inline static const auto           arg = slua_struct< print_help_event >();
        inline static const no_return_type res{};
};

struct slua_runner_def
{
        static auto get_def()
        {
                return std::make_tuple(
                    slua_callback< msg_bind >{},
                    slua_callback< print_config_bind >{},
                    slua_callback< print_help_bind >{},
                    slua_callback< quit_bind >() );
        }
};

}  // namespace schpin
